/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayEditData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayEditData{}

// GatewayEditData struct for GatewayEditData
type GatewayEditData struct {
	ChannelId string `json:"channel_id"`
	Name string `json:"name"`
	Namespace *string `json:"namespace,omitempty"`
}

// NewGatewayEditData instantiates a new GatewayEditData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayEditData(channelId string, name string) *GatewayEditData {
	this := GatewayEditData{}
	this.ChannelId = channelId
	this.Name = name
	return &this
}

// NewGatewayEditDataWithDefaults instantiates a new GatewayEditData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayEditDataWithDefaults() *GatewayEditData {
	this := GatewayEditData{}
	return &this
}

// GetChannelId returns the ChannelId field value
func (o *GatewayEditData) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *GatewayEditData) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *GatewayEditData) SetChannelId(v string) {
	o.ChannelId = v
}

// GetName returns the Name field value
func (o *GatewayEditData) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *GatewayEditData) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *GatewayEditData) SetName(v string) {
	o.Name = v
}

// GetNamespace returns the Namespace field value if set, zero value otherwise.
func (o *GatewayEditData) GetNamespace() string {
	if o == nil || IsNil(o.Namespace) {
		var ret string
		return ret
	}
	return *o.Namespace
}

// GetNamespaceOk returns a tuple with the Namespace field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayEditData) GetNamespaceOk() (*string, bool) {
	if o == nil || IsNil(o.Namespace) {
		return nil, false
	}
	return o.Namespace, true
}

// HasNamespace returns a boolean if a field has been set.
func (o *GatewayEditData) HasNamespace() bool {
	if o != nil && !IsNil(o.Namespace) {
		return true
	}

	return false
}

// SetNamespace gets a reference to the given string and assigns it to the Namespace field.
func (o *GatewayEditData) SetNamespace(v string) {
	o.Namespace = &v
}

func (o GatewayEditData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayEditData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["name"] = o.Name
	if !IsNil(o.Namespace) {
		toSerialize["namespace"] = o.Namespace
	}
	return toSerialize, nil
}

type NullableGatewayEditData struct {
	value *GatewayEditData
	isSet bool
}

func (v NullableGatewayEditData) Get() *GatewayEditData {
	return v.value
}

func (v *NullableGatewayEditData) Set(val *GatewayEditData) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayEditData) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayEditData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayEditData(val *GatewayEditData) *NullableGatewayEditData {
	return &NullableGatewayEditData{value: val, isSet: true}
}

func (v NullableGatewayEditData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayEditData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


